---
title: Turing Documentation
---

# Turing Documentation

Welcome to the documentation for Turing.


## Introduction

**Turing** is a general-purpose probabilistic programming language for robust, efficient Bayesian inference and decision making. Current features include:


  * **General-purpose** probabilistic programming with an intuitive modelling interface;
  * Robust, efficient [Hamiltonian Monte Carlo (HMC)](https://github.com/TuringLang/AdvancedHMC.jl) sampling for differentiable posterior distributions;
  * **Particle MCMC** sampling for complex posterior distributions involving discrete variables and stochastic control flow; and
  * Compositional inference via **Gibbs sampling** that combines particle MCMC, HMC and random-walk MH (RWMH).

